# WSX2MIZ

Utility program to format [Mizar](http://mizar.org) text using WSX as input.

## License

    Copyright 2015-2016 Radosław Piliszek

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>

See included `agpl.txt`

## Dependencies to install manually

[Java SE 8](http://www.oracle.com/technetwork/java/javase/downloads/index.html)
(or later): JDK to compile, JRE to run (included with the JDK).

## How to compile

In this project's root directory run:

    ./gradlew installDist

On Windows:

    gradlew installDist

[Gradle](<http://gradle.org/>) and all other dependencies will be downloaded
as needed. Internet access is required unless they are downloaded already.

## How to install and run

If the previous step finishes successfully, you will have a ready-to-run
distribution of this program in `build/install` (`build\install` on Windows)
under this project's root directory. You can move the `wsx2miz` directory
present there to any suitable location and add its `bin` subdirectory to
your `PATH` variable.

Then you can call `wsx2miz`.

## Usage instructions

Common scenario:

    cd path_to_directory_with_articles
    wsx2miz list of article names separated by spaces

Articles need to be first processed by `accom` and `wsmparser` tools from the
Mizar system.

You can also call `wsx2miz` with a list of directory names. Each `*.wsx` file
in every passed directory will be processed.

By default, `wsx2miz` outputs results to the temporary directory which is
usually not what you want. You can control the output directory using the
`-o` flag.

Example:

    wsx2miz -o/var/mml-pretty /var/mml/nat_1
