/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;

import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;

import net.piliszek.mizar.wsx2miz.MizWriter;

@XmlRootElement(name = "Attributive-Formula")
public class AttributiveFormula extends Formula {

	@XmlElementRef(required = true)
	protected Term term;

	@XmlElementRef(required = true)
	protected AdjectiveCluster adjectiveCluster;

	public Term getTerm() {
		return term;
	}

	public void setTerm(Term term) {
		this.term = term;
	}

	public AdjectiveCluster getAdjectiveCluster() {
		return adjectiveCluster;
	}

	public void setAdjectiveCluster(AdjectiveCluster adjectiveCluster) {
		this.adjectiveCluster = adjectiveCluster;
	}

	@Override
	public void write(MizWriter w) throws IOException {
		term.write(w);
		w.ensureSpace();
		w.write("is");
		w.ensureSpace();
		adjectiveCluster.write(w);
	}

}
