/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;
import java.util.List;

import javax.xml.bind.annotation.XmlSeeAlso;

import net.piliszek.mizar.wsx2miz.MizWriter;

@XmlSeeAlso({
	BlockDefinitionalBlock.class,
	BlockRegistrationBlock.class,
	BlockNotationBlock.class
})
public abstract class BlockDefinition extends Block {

	public abstract String getType();

	public abstract List<Item> getItems();

	@Override
	public void write(MizWriter w) throws IOException {
		w.writeIndent();
		w.write(getType());

		w.newLine();

		w.increaseIndent();
		for (Item item : getItems()) {
			item.write(w);
		}
		w.decreaseIndent();

		w.writeIndent();
		w.write("end");
	}

}
