/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.util.List;

import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "Block-Notation-Block")
public class BlockNotationBlock extends BlockDefinition {

	@XmlElementRefs({
		@XmlElementRef(type = ItemLociDeclaration.class, required = false),
		@XmlElementRef(type = ItemFuncSynonym.class, required = false),
		@XmlElementRef(type = ItemPredSynonym.class, required = false),
		@XmlElementRef(type = ItemPredAntonym.class, required = false),
		@XmlElementRef(type = ItemAttrSynonym.class, required = false),
		@XmlElementRef(type = ItemAttrAntonym.class, required = false),
		@XmlElementRef(type = ItemModeSynonym.class, required = false) })
	protected List<Item> items;

	@Override
	public String getType() {
		return "notation";
	}

	@Override
	public List<Item> getItems() {
		return items;
	}

}
