/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;

import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import net.piliszek.mizar.wsx2miz.MizWriter;

@XmlType(propOrder = { "label", "reasoning" })
@XmlRootElement(name = "Item-Conclusion-Diffuse-Statement")
public class ItemConclusionDiffuseStatement extends ItemConclusion {

	@XmlElementRef(required = false)
	protected Label label;

	@XmlElementRef(required = true)
	protected BlockReasoning reasoning;

	@Override
	public void write(MizWriter w) throws IOException {
		w.writeIndent();
		if (null != label) { // thus [label] now ELSE hereby
			w.write("thus");
			if (label.exists()) {
				w.newLine();
				w.writeIndent();
				w.write(label);
			}
			w.ensureSpace();
		}
		w.write(reasoning);
		w.write(";");
		w.newLine();
	}

}
