/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;

import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import net.piliszek.mizar.wsx2miz.MizWriter;

@XmlType(propOrder = { "variable", "typeList", "formula" })
@XmlRootElement(name = "Item-Private-Predicate-Definition")
public class ItemPrivatePredicateDefinition extends ItemPrivateDefinition {

	@XmlElementRef(required = true)
	protected Variable variable;

	@XmlElementRef(required = true)
	protected TypeList typeList;

	@XmlElementRef(required = true)
	protected Formula formula;

	@Override
	public void write(MizWriter w) throws IOException {
		w.writeIndent();
		w.write("defpred");
		w.ensureSpace();
		variable.write(w);
		w.write("[");
		typeList.write(w);
		w.write("]");
		w.ensureSpace();
		w.write("means");
		w.ensureSpace();
		w.beginSubExp();
		formula.write(w);
		w.endSubExp();
		w.write(";");
		w.newLine();
	}

}
