/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;
import java.util.List;

import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import net.piliszek.mizar.wsx2miz.MizWriter;
import net.piliszek.mizar.wsx2miz.schema.helpers.WSXElement;

@XmlType(propOrder = { "loci" })
@XmlRootElement(name = "Loci")
public class Loci extends WSXElement {

	@XmlElementRef(required = false)
	protected List<Locus> loci;

	public boolean arePresent() {
		return null != loci;
	}

	public boolean areMoreThanOne() {
		return loci.size() > 1;
	}

	public int count() {
		if (null == loci) {
			return 0;
		}
		return loci.size();
	}

	@Override
	public void write(MizWriter w) throws IOException {
		String d = "";
		for (Locus l : loci) {
			w.write(d);
			w.write(l);
			d = ",";
		}
	}

}
