/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;

import net.piliszek.mizar.wsx2miz.FRM;
import net.piliszek.mizar.wsx2miz.MizWriter;
import net.piliszek.mizar.wsx2miz.schema.helpers.PositionalElement;

@XmlRootElement(name = "Mode-Pattern")
public class ModePattern extends PositionalElement {

	@XmlAttribute(name = "nr", required = true)
	protected int nr;

	@XmlAttribute(name = "spelling", required = true)
	protected String spelling;

	@XmlElementRef(required = true)
	protected Loci loci;

	public void register() {
		FRM.registerModeFormat(nr, loci.count());
	}

	public void write(MizWriter w) throws IOException {
		w.write(spelling);
		if (loci.arePresent()) {
			w.ensureSpace();
			w.write("of");
			w.ensureSpace();
			w.write(loci);
		}
	}

}
