/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;

import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;

import net.piliszek.mizar.wsx2miz.MizWriter;

@XmlRootElement(name = "NegatedAdjective")
public class NegatedAdjective extends AdjectiveBase {

	@XmlElementRef(required = true)
	protected Adjective adjective;

	public Adjective getAdjective() {
		return adjective;
	}

	public void setAdjective(Adjective adjective) {
		this.adjective = adjective;
	}

	@Override
	public void write(MizWriter w) throws IOException {
		w.write("non");
		w.ensureSpace();
		adjective.write(w);
	}

}
