/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;
import java.util.List;

import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import net.piliszek.mizar.wsx2miz.MizWriter;

@XmlType(propOrder = { "link", "references" })
@XmlRootElement(name = "Straightforward-Justification")
public class StraightforwardJustification extends SimpleJustification {

	@XmlElementRef(required = false)
	protected Link link;

	@XmlElementRef(required = false)
	protected List<Reference> references;

	@Override
	public boolean hasLink() {
		return link != null;
	}

	@Override
	public boolean hasReferences() {
		return references != null;
	}

	@Override
	public void write(MizWriter w) throws IOException {
		if (hasReferences()) {
			w.beginSubExp();
			w.write("by");
			w.ensureSpace();
			String d = "";
			for (Reference r : references) {
				w.write(d);
				r.write(w);
				d = ",";
			}
			w.endSubExp();
		}
	}

}
