/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;

import javax.xml.bind.annotation.XmlSeeAlso;

import net.piliszek.mizar.wsx2miz.MizWriter;

@XmlSeeAlso({
	AggregateTerm.class,
	CircumfixTerm.class,
	ForgetfulFunctorTerm.class,
	FraenkelTerm.class,
	GlobalChoiceTerm.class,
	InfixTerm.class,
	InternalSelectorTerm.class,
	ItTerm.class,
	NumeralTerm.class,
	PlaceholderTerm.class,
	PrivateFunctorTerm.class,
	QualificationTerm.class,
	SelectorTerm.class,
	SimpleFraenkelTerm.class,
	SimpleTerm.class
})
public abstract class Term extends FormulaOrTerm implements Example {

	public boolean hasPriorityLessThan(int priority) {
		return false;
	}

	public boolean hasPriorityLessThanOrEqual(int priority) {
		return false;
	}

	public void write(MizWriter w, int flags, InfixTerm left, InfixTerm right) throws IOException {
		write(w, flags);
	}

	public void write(MizWriter w, int flags) throws IOException {
		write(w);
	}

	@Override
	public void write(MizWriter w) throws IOException {
		write(w, 0);
	}

}
