/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;

import net.piliszek.mizar.wsx2miz.MizWriter;
import net.piliszek.mizar.wsx2miz.schema.helpers.WSXElement;

@XmlRootElement(name = "Type-List")
public class TypeList extends WSXElement {

	@XmlElementRef(required = false)
	protected List<Type> types;

	@Override
	public void write(MizWriter w) throws IOException {
		if (null == types) {
			return;
		}
		Iterator<Type> it = types.iterator();
		while (true) {
			Type t = it.next();
			if (it.hasNext()) {
				t.write(w, UNSAFE_RIGHT_DANGLING_COMMA);
				w.write(",");
				w.ensureSpace();
			} else {
				t.write(w, 0);
				break;
			}
		}
	}

}
