/*******************************************************************************
 * Copyright 2015-2016 Radosław Piliszek
 *
 * This file is part of WSX2MIZ.
 *
 * WSX2MIZ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * WSX2MIZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WSX2MIZ.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package net.piliszek.mizar.wsx2miz.schema.helpers;

import java.io.IOException;

import net.piliszek.mizar.wsx2miz.MizWriter;

public abstract class WSXElement {

	public static final int UNSAFE_RIGHT_DANGLING_TERM = 1;
	public static final int UNSAFE_LEFT_DANGLING_TERM = 2;

	public static final int UNSAFE_RIGHT_DANGLING_COMMA = 4;

	public static final int UNSAFE_RIGHT_DANGLING_FORMULA = 8;

	public static final int UNSAFE_RIGHT_WEAK_FUNCTOR = 16;
	public static final int UNSAFE_LEFT_WEAK_FUNCTOR = 32;

	public static final int UNSAFE_RIGHT_FUNCTOR = 64;
	public static final int UNSAFE_LEFT_FUNCTOR = 128;

	public static final int UNSAFE_LEFT_PAREN = 256;
	public static final int UNSAFE_RIGHT_PAREN = 512;

	public static final int UNSAFE_RIGHT_MASK = 0
			| UNSAFE_RIGHT_DANGLING_TERM
			| UNSAFE_RIGHT_DANGLING_COMMA
			| UNSAFE_RIGHT_DANGLING_FORMULA
			| UNSAFE_RIGHT_WEAK_FUNCTOR
			| UNSAFE_RIGHT_FUNCTOR
			| UNSAFE_RIGHT_PAREN;

	public static final int UNSAFE_LEFT_MASK = 0
			| UNSAFE_LEFT_DANGLING_TERM
			| UNSAFE_LEFT_WEAK_FUNCTOR
			| UNSAFE_LEFT_FUNCTOR
			| UNSAFE_LEFT_PAREN;

	public abstract void write(MizWriter w) throws IOException;

}
